import collections




def f(n, m, k, r, g):
    graph = collections.defaultdict(list)
    for a, b in r:
        graph[a].append(b)
        graph[b].append(a)
    
    ans = set()
    
    def d(start, v):
        st = collections.deque([(start, 0)])
        visited = set()
        visited.add(start)
        
        while st:
            cur, distance = st.popleft()
            if distance > v:
                continue
            
            ans.add(cur)
            
            for s in graph[cur]:
                if s in visited: 
                    continue
                else:
                    visited.add(s)
                    st.append((s, distance + 1))
    
    for start, h in g:
        d(start, h)
    
    ans = sorted(ans)
    return len(ans), ans


n, m, k = map(int, input().split())
r = [list(map(int, input().split())) for _ in range(m)]
g = [list(map(int, input().split())) for _ in range(k)]


count, ans = f(n, m, k, r, g)
if count > 0:
    print(count)
    print(*ans)
else:
    print()

